<?php

/**
 * @file
 * Imagepin theme implementations.
 */

use Drupal\Core\Template\Attribute;

/**
 * Preprocess for showing imapepin widgets.
 *
 * @param array &$variables
 *   The variables array.
 */
function template_preprocess_imagepin_widgets(array &$variables) {
  $variables['attributes'] = new Attribute(['class' => ['imagepin-widgets'], 'data-imagepin-attach-to' => $variables['attach_id']]);
  foreach ($variables['widgets'] as $key => $widget) {
    $pin = [
      '#type' => 'container',
      '#attributes' => ['class' => ['imagepin'], 'data-imagepin-key' => $key],
      'content' => $widget['plugin']->viewPinContent($widget['value']),
    ];
    if ($position = $widget['plugin']->getPosition($widget['value'])) {
      $pin['#attributes']['data-position-default'] =
        \Drupal::service('serialization.json')->encode($position);
    }
    $variables['items'][$key] = [
      'attributes' => new Attribute(['class' => ['imagepin-widget'], 'data-imagepin-key' => $key, 'data-imagepin-overlay-class' => 'imagepin-widget imagepin-selected imagepin-overlay']),
      'pin' => $pin,
      'content' => $widget['plugin']->viewContent($widget['value']),
      'content_attributes' => new Attribute(['class' => ['imagepin-widget-content']]),
    ];
  }
}
